jQuery(function ($) {
    var media = wp.media;
    if (wp.media) {
        var wpAttachmentDetailsTwoColumn =
            media.view.Attachment.Details.TwoColumn;
        if (wpAttachmentDetailsTwoColumn) {
            media.view.Attachment.Details.TwoColumn =
                wpAttachmentDetailsTwoColumn.extend({
                    render: function () {
                        this.fetchProviderDetails(this.model.get("id"));
                    },

                    fetchProviderDetails: function (id) {
                        var classObject = this;
                        $.ajax({
                            type: "POST",
                            url: window.acoofm_media_object.admin_ajax_url,
                            data: {
                                action: "acoofm_get_attachment_details",
                                id: id,
                                _nonce: window.acoofm_media_object
                                    .file_details_nonce,
                            },
                            dataType: "json",
                            success: function (response) {
                                classObject.renderView(response);
                            },
                        });
                    },

                    renderView: function (response) {
                        // Render parent media.view.Attachment.Details
                        wpAttachmentDetailsTwoColumn.prototype.render.apply(
                            this
                        );

                        this.renderServerDetails(response);
                    },

                    renderServerDetails: function (response) {
                        if (response.status) {
                            var $actionsHtml = this.$el.find(".details");
                            var data = response.data;
                            var append = [];
                            if (data.provider) {
                                var providerHtml =
                                    "<div class='acoofm_provider'><strong>" +
                                        window.acoofm_media_object.strings
                                            .provider +
                                        "</strong>" +
                                        data.provider.label ||
                                    data.provider.slug + "</div>";
                                append.push(providerHtml);
                            }
                            if (data.region) {
                                var regionHtml =
                                    "<div class='acoofm_region'><strong>" +
                                    window.acoofm_media_object.strings.region +
                                    "</strong>" +
                                    data.region +
                                    "</div>";
                                append.push(regionHtml);
                            }
                            if (append.length) {
                                append.forEach((element, key) => {
                                    $actionsHtml.append(element);
                                });
                            }
                        }
                    },
                });
        }
    }
});
