<?php
/**
 * Plugin Name: Offload Media - Cloud Storage
 * Version: 1.0.3
 * Description: Offload Media - Cloud Storage helps to offload your wordpress media to the cloud server services.
 * Author: Acowebs
 * Author URI: http://acowebs.com
 * Requires at least: 4.4.0
 * Tested up to: 6.0
 * Requires PHP: 7.0 or higher
 * Text Domain: offload-media-cloud-storage
 */
 
if (!defined('ABSPATH')) {
    exit;
}
global $wpdb;

define('ACOOFM_TOKEN', 'acoofm');
define('ACOOFM_VERSION', '1.0.3');
define('ACOOFM_FILE', __FILE__);
define('ACOOFM_PLUGIN_NAME', 'Offload Media - Cloud Storage');
define('ACOOFM_OPTION_NAME', 'acoofm_settings');
define('ACOOFM_ITEM_TABLE', $wpdb->prefix . ACOOFM_TOKEN .'_items');
define('ACOOFM_DB_VERSION', '1.0.1');
define('ACOOFM_CACHE_GROUP', ACOOFM_TOKEN.'_cache');
define('ACOOFM_CACHE_KEY_PREFIX', ACOOFM_TOKEN.'_cache_key_');
define('ACOOFM_CACHE_EXPIRY', 24*60*60);
define('ACOOFM_ATTACHMENT_META_KEY', ACOOFM_TOKEN.'_item_id');
define('ACOOFM_S3_MULTIPART_UPLOAD_MINIMUM_SIZE', 5242880);
define('ACOOFM_GOOGLE_MULTIPART_UPLOAD_MINIMUM_SIZE', 5242880);
define('ACOOFM_DIGITAL_OCEAN_MULTIPART_UPLOAD_MINIMUM_SIZE', 5242880);
define('ACOOFM_UPLOADS', 'acoofm_uploads');


// Helpers.
require_once realpath(plugin_dir_path(__FILE__)) . DIRECTORY_SEPARATOR . 'includes/helpers.php';

// Init.
add_action('plugins_loaded', 'acoofm_init');
if (!function_exists('acoofm_init')) {
    /**
     * Load plugin text domain
     *
     * @return  void
     */
    function acoofm_init()
    {
        $plugin_rel_path = basename(dirname(__FILE__)) . '/languages'; /* Relative to WP_PLUGIN_DIR */
        load_plugin_textdomain('offload-media-cloud-storage', false, $plugin_rel_path);
    }
}

// Loading Classes.
if (!function_exists('ACOOFM_autoloader')) {

    function ACOOFM_autoloader($class_name)
    {
        if (0 === strpos($class_name, 'ACOOFM')) {
            $classes_dir = realpath(plugin_dir_path(__FILE__)) . DIRECTORY_SEPARATOR . 'includes' . DIRECTORY_SEPARATOR;
            $class_file = 'class-' . str_replace('_', '-', strtolower($class_name)) . '.php';
            if(file_exists($classes_dir . $class_file)){
                require_once $classes_dir . $class_file;
            } else {
                require_once $classes_dir . 'services' . DIRECTORY_SEPARATOR . $class_file;
            }
        }
        
        //include services
        require_once realpath(plugin_dir_path(__FILE__)) . DIRECTORY_SEPARATOR .'includes/s3/vendor/autoload.php';
        require_once realpath(plugin_dir_path(__FILE__)) . DIRECTORY_SEPARATOR .'includes/google/vendor/autoload.php';
    }
}
spl_autoload_register('ACOOFM_autoloader');

// Backend UI.
if (!function_exists('ACOOFM_Backend')) {
    function ACOOFM_Backend()
    {
        return ACOOFM_Backend::instance(__FILE__);
    }
}
if (!function_exists('ACOOFM_Public')) {
    function ACOOFM_Public()
    {
        return ACOOFM_Public::instance(__FILE__);
    }
}
if (!function_exists('ACOOFM_Compatibility')) {
    function ACOOFM_Compatibility()
    {
        return ACOOFM_COMPATIBILITY::instance(__FILE__);
    }
}
if (!function_exists('ACOOFM_Rewrite_url')) {
    function ACOOFM_Rewrite_url()
    {
        return ACOOFM_REWRITEURL::instance(__FILE__);
    }
}
// Front end.
ACOOFM_Public();
if (is_admin()) {
    ACOOFM_Backend();
}
ACOOFM_Compatibility();
ACOOFM_Rewrite_url();
new ACOOFM_Api();
global $acoofmItem;
$acoofmItem = new ACOOFM_ITEM;